#include <amxmodx>

#define PLUGIN "WordGame"
#define VERSION "1.0"
#define AUTHOR "Larisaios"

#define ACCESS_TO_WORDGAME ADMIN_KICK

// Cvars Stuff
new g_enabled
new g_prefix
new g_methodwrite
new g_sound

// WordGame Stuff
new WordGameStatus 
new is_admin[33]
new Word[30]
new choosenword[33][32]
new wordmaster

new const Sound[] = "sound/wordgame/ding.mp3"

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_clcmd("say /wordgame", "wordgame")
	register_clcmd("say_team /wordgame", "wordgame")
	register_clcmd("write_a_word_here", "wordhere")
	register_clcmd("say", "handle_say")
	
	g_enabled = register_cvar("wg_enabled", "1")
	g_prefix = register_cvar("wg_prefix", "[WordGame]")
	g_methodwrite = register_cvar("wg_writemethod", "1")
	
	register_dictionary("wordgame.txt")
}

public plugin_precache()
{
	g_sound = register_cvar("wg_sound", "1")
	
	if(get_pcvar_num(g_sound) == 1)
	{
		precache_generic(Sound)
	}
}

public client_authorized(id)
{
	if(get_user_flags(id) & ACCESS_TO_WORDGAME)
	{
		is_admin[id] = true
	}
}

public wordgame(id)
{
	if(!is_user_alive(id))
	return PLUGIN_CONTINUE
	
	new prefix[15]; 
	get_pcvar_string(g_prefix, prefix, charsmax(prefix));
	
	if(get_pcvar_num(g_enabled))
	{
		if(!is_admin[id] && get_user_team(id) != 2)
		{
			client_print(id, print_chat, "%L", id, "WG_NOACCESS", prefix)
		}
		if(WordGameStatus)
		{
			client_print(id, print_chat, "%L", id, "WG_ALREADY", prefix)
		}
		else if(is_admin[id] || get_user_team(id) == 2)
		{
			wordmaster = id
			client_cmd(id, "messagemode write_a_word_here")
			
		}
	}
	else
		client_print(id, print_chat, "%L", id, "WG_DISABLED", prefix)
		
	return PLUGIN_HANDLED
}

public wordhere(id)
{ 
	new prefix[15]; 
	get_pcvar_string(g_prefix, prefix, charsmax(prefix));
	
	if(wordmaster != id)
	{
		client_print(id, print_chat, "%L", id, "WG_NOACCESS", prefix)
	}
	else
	{
		read_args(Word, charsmax(Word))
		remove_quotes(Word)
		
		copy(choosenword[id],charsmax(choosenword[]),Word)
		
		choosen_word(id)
	}
}

public choosen_word(id)
{
	new WordMasterName[32] 
	get_user_name(wordmaster, WordMasterName, charsmax(WordMasterName))

	set_hudmessage(0, 0, 255, -1.0, 0.04, 0, 6.0, 5.0)
	show_hudmessage(0, "%L", 0, "WG_CHOOSENWORD", WordMasterName, choosenword[id])
	
	WordGameStatus = 1
}

public handle_say(id)
{
	new prefix[15]; 
	get_pcvar_string(g_prefix, prefix, charsmax(prefix));
	
	if(WordGameStatus)
	{
		new Arg[32];
		read_args(Arg, charsmax(Arg));
		remove_quotes(Arg);
		
		if(get_pcvar_num(g_methodwrite) == 1)
		{
			if(equal(Arg,choosenword[id]) && get_user_team(id) != 1)
			{
				client_print(id, print_chat, "%L", id, "WG_ONLYALIVETERRORIST", prefix)
			}
			if(get_user_team(id) == 1 && is_user_alive(id))
			{
				if(!equal(Arg,choosenword[id]))
				{
					client_print(id, print_chat, "%L", id, "WG_DONTWROTECORRECTLY", prefix)
				}
				else if(equal(Arg,choosenword[id]))
				{
					new Name[32];
					get_user_name(id, Name, charsmax(Name));
					set_hudmessage(255, 255, 127, -1.0, 0.55, 0, 6.0, 4.0)
					show_hudmessage(0, "%L", 0, "WG_FIRSTSHOWMETHOD1", Name, choosenword[id])
					
					if(get_pcvar_num(g_sound))
					{
						client_cmd(0, "mp3 play %s", Sound)
					}
					
					choosenword[id][0] = '^0'
					WordGameStatus = 0
					wordmaster = 0
				
					return PLUGIN_HANDLED
				}
			}
		}
		else if(get_pcvar_num(g_methodwrite) == 0)
		{
			if(containi(Arg,choosenword[id]) && get_user_team(id) != 1)
			{
				client_print(id, print_chat, "%L", id, "WG_ONLYALIVETERRORIST", prefix)
			}
			if(get_user_team(id) == 1 && is_user_alive(id))
			{
				if(containi(Arg,choosenword[id]))
				{
					new Name[32];
					get_user_name(id, Name, charsmax(Name));
					set_hudmessage(255, 255, 127, -1.0, 0.55, 0, 6.0, 4.0)
					show_hudmessage(0, "%L", 0, "WG_FIRSTSHOWMETHOD0", Name, choosenword[id])
					
					if(get_pcvar_num(g_sound))
					{
						client_cmd(0, "mp3 play %s", Sound)
					}
					
					choosenword[id][0] = '^0'
					WordGameStatus = 0
					wordmaster = 0
				
					return PLUGIN_HANDLED
				}
			}
		}
			
	}
	
	return PLUGIN_CONTINUE;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1063\\ f0\\ fs16 \n\\ par }
*/
